package aokai.app.BMSPayer;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.view.KeyEvent;
import android.view.Window;

public class Game_test extends Activity {
	private TickHandler tickHandler;
	private DatabaseOpenHelper dbHelpar;
	private SQLiteDatabase db;
	Intent intent;
	Read_HEADERFile All_bms;
	Read_BMSFile BMS = new Read_BMSFile();
	Game_test_sur view;
	SharedPreferences pref;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		intent = getIntent();
		All_bms = (Read_HEADERFile) intent
				.getSerializableExtra("Read_HEADERFile");
		BMS.Read(All_bms.file_path, All_bms.file_name);
		// タイトルバーを削除
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		//現状で固定
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);
		// SurfaceViewを登録
		// SharedPrefernces の取得
		pref = PreferenceManager.getDefaultSharedPreferences(this);
		view = new Game_test_sur(this, BMS.make_Lite_BMSFile(),
				Integer.parseInt(pref.getString("game_type", "0")));
		if (view.BGM == null) {
			finish();
		}
		// データーベースオブジェクトの取得
		dbHelpar = new DatabaseOpenHelper(this);
		db = dbHelpar.getWritableDatabase();
		Game_test_sur.show_time = Integer.parseInt(pref.getString(
				"showtime_preference", "1000"));
		view.leanposition = Integer.parseInt(pref.getString(
				"leanpostion_preference", "100"));
		view.lean_flag = pref
				.getBoolean("leanCaver_checkbox_preference", false);
		view.auto_flag = pref.getBoolean("outo_checkbox_preference", false);
		view.cont_time = Integer.parseInt(pref.getString("stoptime_preference",
				"0"));

		setContentView(view);
	}

	public boolean dispatchKeyEvent(KeyEvent event) {
		if (event.getAction() == KeyEvent.ACTION_DOWN) {
			switch (event.getKeyCode()) {
			case KeyEvent.KEYCODE_BACK:
				return true;
			}
		}
		if (event.getAction() == KeyEvent.ACTION_UP) {
			switch (event.getKeyCode()) {
			case KeyEvent.KEYCODE_BACK:
				view.BGM.stop();
				view.tread_flag = false;
				return true;
			}
		}
		return super.dispatchKeyEvent(event);
	}

	// アプリの再開
	@Override
	public void onResume() {
		super.onResume();

		// 定期処理はランドの開始
		tickHandler = new TickHandler();
		tickHandler.sleep(0);
	}

	@Override
	public void onPause() {
		super.onPause();

		// 定期処理ハンドラの停止
		tickHandler = null;
	}

	
	@Override
	public void onDestroy() {
		super.onDestroy();
	}

	public class TickHandler extends Handler {
		@Override
		public void handleMessage(Message msg) {
			if (tickHandler != null) {
				tickHandler.sleep(0);
			}
		}

		public void sleep(long delayMills) {
			boolean temp = true;
			for(int i = 0;i<8;i++){
				if(view.L_bms.chkey[i][view.now_position[i]] !=999999){
					temp =false;
				}
			}
			if (view.end_flag == true) {
				if (!view.auto_flag) {
					dbHelpar.scoreUpdate(db, All_bms, view.score,
							view.now_MISS, view.now_Maxcombo, view.game_type,
							view.gage_score,temp);
				}
				finish();
			}
			removeMessages(0);
			sendMessageDelayed(obtainMessage(0), delayMills);
		}
	}
}
