package aokai.app.BMSPayer;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;

import android.graphics.Rect;
import android.graphics.Paint.Style;
import android.media.MediaPlayer;
import android.net.Uri;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.MotionEvent;
import android.widget.Toast;

public class Game_test_sur extends SurfaceView implements
		SurfaceHolder.Callback, Runnable {
	public Lite_BMSFile L_bms;
	public boolean type = false;
	public long start_time;
	public long finishtime;
	private long temp_time;
	public int i, j, k, l, m;
	public Context context;
	public MediaPlayer BGM = null;
	public static long now_time;
	public int[] now_position = new int[9];
	public int[] finish_position = new int[9];
	public Canvas canvas = new Canvas();
	public Paint paint = new Paint();
	private static Point[] keyPoint = new Point[9];
	private static Rect[] keyRect = new Rect[8];
	public boolean tread_flag = true;
	public static int show_time = 1000;
	public static final int judg_line = 392;
	public static final int sleeptime = 8000;
	public long fpstime = System.currentTimeMillis();
	public int fpscount = 0;
	public float fps = 0;
	public long fpscontrol = 0;
	public Buttons[] button = new Buttons[8];
	public Buttons all_button = new Buttons();
	private int pointerCount;
	private Bitmap frame;
	private Bitmap leancaver;
	private Bitmap marker;
	private Bitmap line_eff1;
	private Bitmap line_eff2;
	private Bitmap line_eff3;
	private Bitmap[] shutter = new Bitmap[2];
	private Bitmap[] Gage = new Bitmap[4];
	private int[] line_eff_count = new int[9];
	private static final int line_eff_time = 20;
	private static final int markerY1 = 25;
	private static final int markerY2 = 350;
	private static final int markerX = 11;
	public int leanposition;
	public int leanposition_temp = -1;
	public boolean lean_flag;// レーンカバーの有り無し
	public int score;
	public int now_Maxcombo;// 現在の最大コンボ数
	public int now_MISS;// 現在のミスの数（始めノート数でどんどん減っていく）
	public static int combo;// 現在のコンボ
	public boolean auto_flag;// オートかどうか
	public int cont_time = 0;// 設定によって決められたオフセットタイム
	public boolean flame_flag = true;// 描写を２回に一回にする
	public double gage_score;// 現在のゲージ残高
	public double gage_up;// ゲージの増加量
	public double gage_down;// ゲージのヘリ具合
	public int game_type;// ０＝ノーマル；1=イージ；２＝ハード
	// スレッドクラス
	private Thread thread;
	private SurfaceHolder holder;
	public boolean end_flag;
	private boolean hard_shutter;
	private int[] result_glaf = new int[100];
	private int[] Hantei = new int[3];
	private int Timing;//判定タイミング0 = ジャスト　-1 = slow 1 = fast

	public Game_test_sur(Context context, Lite_BMSFile L_bms, int game_type) {
		super(context);
		this.context = context;
		this.L_bms = L_bms;
		// setBackgroundColor(Color.WHITE);
		setFocusable(true);
		BGM_load();
		BGM.start();
		this.game_type = game_type;
		Timing = 0;
		now_Maxcombo = 0;
		now_MISS = L_bms.Max_noat;
		score = 0;
		for (i = 0; i < 3; i++) {
			Hantei[i] = 0;
		}
		end_flag = false;
		hard_shutter = false;
		// イメージのロード
		frame = BitmapFactory.decodeResource(getResources(), R.drawable.frame);
		leancaver = BitmapFactory.decodeResource(getResources(),
				R.drawable.leancaver);
		marker = BitmapFactory
				.decodeResource(getResources(), R.drawable.marker);
		line_eff1 = BitmapFactory.decodeResource(getResources(),
				R.drawable.line_eff1);
		line_eff2 = BitmapFactory.decodeResource(getResources(),
				R.drawable.line_eff2);
		line_eff3 = BitmapFactory.decodeResource(getResources(),
				R.drawable.line_eff3);
		shutter[0] = Bitmap.createBitmap(BitmapFactory.decodeResource(
				getResources(), R.drawable.shutter), 0, 0, 320, 255);
		shutter[1] = Bitmap.createBitmap(BitmapFactory.decodeResource(
				getResources(), R.drawable.shutter), 0, 255, 320, 255);
		for (i = 0; i < 4; i++) {
			Gage[i] = Bitmap.createBitmap(BitmapFactory.decodeResource(
					getResources(), R.drawable.gage), i * 7, 0, 7, 26);
		}
		tread_flag = true;
		for (i = 0; i < 8; i++) {
			button[i] = new Buttons();
			line_eff_count[i] = 0;
		}
		finishtime = BGM.getDuration() + sleeptime;

		for (i = 0; i < 9; i++) {
			now_position[i] = 0;
			finish_position[i] = 0;
		}
		// ゲージ履歴の初期化
		for (i = 0; i < 100; i++) {
			result_glaf[0] = 0;
		}

		combo = 0;
		// ゲージの減り具合の定義
		switch (game_type) {
		case 0:// ノーマル
			gage_up = L_bms.TOTAL / L_bms.Max_noat; // (#TOTAL で指定した値) / (BMS
			// の総オブジェ数)
			gage_down = 6.0;
			gage_score = 20.0;
			break;
		case 1:// イージ～
			gage_up = L_bms.TOTAL / L_bms.Max_noat; // (#TOTAL で指定した値) / (BMS
			// の総オブジェ数)
			gage_down = 4.8;
			gage_score = 20.0;
			break;
		case 2:// ハード
			gage_up = 0.16;
			gage_down = 9.0;
			gage_score = 100.0;
			break;
		}

		// keyRect[0]は円の定義だから間違えるなよ！！
		keyPoint[0] = new Point(22, 61);
		keyPoint[1] = new Point(65, 88);
		keyPoint[2] = new Point(90, 108);
		keyPoint[3] = new Point(110, 132);
		keyPoint[4] = new Point(134, 152);
		keyPoint[5] = new Point(154, 176);
		keyPoint[6] = new Point(179, 196);
		keyPoint[7] = new Point(199, 221);
		keyPoint[8] = new Point(20, 221);

		// ボタンの位置
		keyRect[0] = new Rect(10, judg_line + 10, 70, 500);
		keyRect[1] = new Rect(70, 445, 130, 500);
		keyRect[2] = new Rect(100, judg_line + 10, 160, 460);
		keyRect[3] = new Rect(130, 445, 190, 500);
		keyRect[4] = new Rect(160, judg_line + 10, 220, 460);
		keyRect[5] = new Rect(190, 445, 250, 500);
		keyRect[6] = new Rect(220, judg_line + 10, 280, 460);
		keyRect[7] = new Rect(250, 445, 310, 500);

		for (i = 0; i < 8; i++) {
			button[i].set(keyRect[i]);
		}
		// サーフェイスホルダーの作成
		holder = getHolder();
		holder.addCallback(this);
		holder.setFixedSize(getWidth(), getHeight());
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		pointerCount = event.getPointerCount();
		for (int i = 0; i < pointerCount; i++) {
			all_button.touch(event.getX(i), event.getY(i));
			for (l = 0; l < 8; l++) {
				if (button[l].push_flag != true) {
					button[l].touch(event.getX(i), event.getY(i));
				}
			}
		}
		if (all_button.push_flag == false) {
			all_button.touch_flag = false;
		}
		;
		for (l = 0; l < 8; l++) {
			if (button[l].push_flag == false) {
				button[l].touch_flag = false;
			}
		}
		switch (event.getAction()) {
		case MotionEvent.ACTION_DOWN:

			if (22 < event.getX() && 221 > event.getX()
					&& event.getY() < leanposition) {
				leanposition_temp = leanposition - (int) event.getY();
			}
			break;
		case MotionEvent.ACTION_MOVE:
			if (leanposition_temp != -1) {
				leanposition = (int) (event.getY() + leanposition_temp);
				// leanposition_temp = leanposition - (int) event.getY();
			}
			break;
		case MotionEvent.ACTION_UP:
			leanposition_temp = -1;
			all_button.touch_flag = false;
			for (l = 0; l < 8; l++) {
				button[l].touch_flag = false;
			}
		}
		return true;
	}

	public void run() {
		BGM = null;
		BGM_load();
		all_button.set(new Rect(0, 0, getWidth(), getHeight()));
		// Runnableインターフェースをimplementsしているので、runメソッドを実装する
		// これは、Threadクラスのコンストラクタに渡すために用いる。
		// fps
		start_time = System.currentTimeMillis();
		while (tread_flag) {
			fpscontrol = System.currentTimeMillis();
			Update_time();
			Update();
			if (flame_flag) {
				Draw();
				flame_flag = false;
			} else {
				flame_flag = true;
			}

			fpscount++;
			if (fpscount >= 12) {
				fps = 1000f / (System.currentTimeMillis() - fpstime) * fpscount;
				fpstime = System.currentTimeMillis();
				fpscount = 0;
			}
			// if (System.currentTimeMillis() - fpscontrol < 33) {
			// try {
			// Thread.sleep(33 - System.currentTimeMillis() + fpscontrol);
			// } catch (InterruptedException e) {
			// e.printStackTrace();
			// }
			// }
		}
		int y1 = 0;
		int y2 = 510;
		while (hard_shutter) {
			Draw_Hard(y1, y2);
			if (y1 > y2) {
				try {
					Thread.sleep(1000);
				} catch (InterruptedException e) {
					// TODO 自動生成された catch ブロック
					e.printStackTrace();
				}
				hard_shutter = false;
			} else {
				y1 += 10;
				y2 -= 10;
			}
		}

		if (auto_flag == false) {
			for (int time = 0; time <= 100; time++) {
				Draw_Result(time);
			}
			while (all_button.touch_flag == false) {
			}
		}
		end_flag = true;
	}

	public void Update_time() {
		if (type == false) {
			// sleeptimeの間(曲が流れていない時)のnow_timeの更新
			now_time = System.currentTimeMillis() - start_time;
			if (now_time >= sleeptime) {
				BGM.start();
				type = true;
			}
		} else {
			if (BGM.isPlaying()) {
				/*****************パターンA*********************/
//				if(BGM.getCurrentPosition() + sleeptime == now_time){
//					now_time += System.currentTimeMillis() - temp_time;
//				}else{
//					now_time = BGM.getCurrentPosition() + sleeptime;
//				}
//				temp_time = System.currentTimeMillis();
				
				/*****************パターンB*********************/
				now_time = System.currentTimeMillis() - start_time;
			} else {
				// 曲が終了してしまった場合のnow_timeの更新
				now_time = System.currentTimeMillis() - start_time;
			}
		}
	}

	public void Update() {
		j = (int) (now_time * 100 / finishtime);
		if (j > 99) {
			j = 99;
		}
		result_glaf[j] = (int) gage_score;
		for (i = 0; i < 8; i++) {
			if (button[i].push_flag == true) {
				if (L_bms.chkey[i][finish_position[i]] - now_time < 100) {
					if (L_bms.chkey[i][finish_position[i]] - now_time < 40
							&& L_bms.chkey[i][finish_position[i]] - now_time > -40) {
						Hantei[2]++;
						score += 2;
						Timing = 0;
					} else {
						score += 1;
						Hantei[1]++;
						if(L_bms.chkey[i][finish_position[i]] - now_time >0){
							Timing = 1;
						}else{
							Timing= -1;
						}
					}
					combo++;
					if (now_Maxcombo <= combo) {
						now_Maxcombo = combo;
					}
					now_MISS--;
					gage_score += gage_up;
					if (gage_score >= 100) {
						gage_score = 100;
					}
					finish_position[i]++;
				}
				line_eff_count[i] = line_eff_time;
				button[i].push_flag = false;
			}
		}
		// 最後の小節ラインが降ったら終了(これが呼ばれるとループを抜ける)
		if (L_bms.chkey[8][finish_position[8]] == 999999) {
			int temp = 0;
			for (i = 0; i < 100; i++) {
				if (result_glaf[i] == 0) {
					result_glaf[i] = temp;
				} else {
					temp = result_glaf[i];
				}
			}
			tread_flag = false;
		}
		// 新規ノート
		for (i = 0; i < 9; i++) {
			if ((L_bms.chkey[i][now_position[i]] - show_time) < now_time) {
				now_position[i]++;
			}
		}
		// ノートのタイムアウト
		for (i = 0; i < 8; i++) {
			if ((L_bms.chkey[i][finish_position[i]] + 200) < now_time) {
				Hantei[0]++;
				combo = 0;
				gage_score -= gage_down;
				// ハードでゲージがなくなったらゲームオーバー
				if (gage_score < 2 && game_type == 2) {
					BGM.stop();
					tread_flag = false;
					hard_shutter = true;
				}
				if (gage_score <= 2.0) {
					gage_score = 2;
				}
				finish_position[i]++;
			}
		}
		if ((L_bms.chkey[8][finish_position[8]]) < now_time) {
			finish_position[8]++;
		}
	}

	public void Draw() {
		canvas = holder.lockCanvas();
		// 背景の描画
		canvas.drawColor(Color.rgb(0, 0, 0));
		// フレームの描写
		canvas.drawBitmap(frame, 0, 0, null);
		// ゲージの描写
		// とりあえずjにゲージ量を代入数行したのゲージ％の描写にも使われているので注意
		j = (int) gage_score / 2;
		if (game_type == 2) {
			// ハード時のゲージ
			for (i = 0; i < 50; i++) {
				if (j > i) {
					if (j - i == 2) {
						if (now_time % 3 != 2) {
							canvas.drawBitmap(Gage[2], 8 + i * 6, 473, paint);
						} else {
							canvas.drawBitmap(Gage[0], 8 + i * 6, 473, paint);
						}
					} else if (j - i == 3) {
						if (now_time % 3 == 0) {
							canvas.drawBitmap(Gage[2], 8 + i * 6, 473, paint);
						} else {
							canvas.drawBitmap(Gage[0], 8 + i * 6, 473, paint);
						}
					} else {
						canvas.drawBitmap(Gage[0], 8 + i * 6, 473, paint);
					}
				} else {
					canvas.drawBitmap(Gage[2], 8 + i * 6, 473, paint);
				}
			}
		} else {
			// ノーマル・イージー時のゲージ
			for (i = 0; i < 50; i++) {
				if (i > 38) {
					if (j > i) {
						if (j - i == 2) {
							if (now_time % 3 != 2) {
								canvas.drawBitmap(Gage[2], 8 + i * 6, 473,
										paint);
							} else {
								canvas.drawBitmap(Gage[0], 8 + i * 6, 473,
										paint);
							}
						} else if (j - i == 3) {
							if (now_time % 3 == 0) {
								canvas.drawBitmap(Gage[2], 8 + i * 6, 473,
										paint);
							} else {
								canvas.drawBitmap(Gage[0], 8 + i * 6, 473,
										paint);
							}
						} else {
							canvas.drawBitmap(Gage[0], 8 + i * 6, 473, paint);
						}
					} else {
						canvas.drawBitmap(Gage[2], 8 + i * 6, 473, paint);
					}
				} else {
					if (j > i) {
						if (j - i == 2) {
							if (now_time % 3 != 2) {
								canvas.drawBitmap(Gage[3], 8 + i * 6, 473,
										paint);
							} else {
								canvas.drawBitmap(Gage[1], 8 + i * 6, 473,
										paint);
							}
						} else if (j - i == 3) {
							if (now_time % 3 == 0) {
								canvas.drawBitmap(Gage[3], 8 + i * 6, 473,
										paint);
							} else {
								canvas.drawBitmap(Gage[1], 8 + i * 6, 473,
										paint);
							}
						} else {
							canvas.drawBitmap(Gage[1], 8 + i * 6, 473, paint);
						}
					} else {
						canvas.drawBitmap(Gage[3], 8 + i * 6, 473, paint);
					}
				}
			}
		}
		// ゲージ％の描写
		paint.setTextSize(30);
		canvas.drawText(j * 2 + "", 230, 460, paint);
		// 時間マーカーの描写
		if (type) {
			canvas.drawBitmap(marker, markerX,
					markerY1 + (markerY2 - markerY1) * (now_time - sleeptime)
							/ (float) (finishtime - sleeptime), null);
		} else {
			if ((now_time) * 4 < sleeptime) {
				canvas.drawBitmap(marker, markerX, markerY2
						- (markerY2 - markerY1) * (now_time) * 4
						/ (float) sleeptime, null);
			} else {
				canvas.drawBitmap(marker, markerX, markerY1, null);
			}
		}
		// scoreグラフ
		int G_top = 37;
		int G_wid = 248;
		paint.setTextSize(12);
		paint.setColor(Color.GREEN);
		paint.setStrokeWidth(1);
		canvas.drawRect(270, G_top + G_wid - G_wid* score / (L_bms.Max_noat * 2), 307, G_top
				+ G_wid, paint);
		paint.setColor(Color.rgb(128,128,255));
		canvas.drawLine(233, G_top + G_wid * 1 / 9, 310, G_top + G_wid * 1 / 9,
				paint);
		canvas.drawLine(233, G_top + G_wid * 2 / 9, 310, G_top + G_wid * 2 / 9,
				paint);
		canvas.drawLine(233, G_top + G_wid * 3 / 9, 310, G_top + G_wid * 3 / 9,
				paint);

		// fps描写
		paint.setColor(Color.WHITE);
		paint.setStrokeWidth(2);
		canvas.drawText("fps = " +(int)fps, 235, 13, paint);
		canvas.drawText("EXscore:" + score+"/"+L_bms.Max_noat * 2, 235, 320, paint);
		canvas.drawText("GREAT:" + Hantei[2], 235, 335, paint);
		canvas.drawText("GOOD:" + Hantei[1], 235, 350, paint);
		canvas.drawText("MISS :" + Hantei[0], 235, 365, paint);

		// キーの輪郭描画
		if (!auto_flag) {
			paint.setStyle(Style.STROKE);
			paint.setColor(Color.RED);
			for (i = 0; i < 8; i++) {
				canvas.drawRect(keyRect[i], paint);
			}
		}
		paint.setStyle(Paint.Style.FILL);
		paint.setStrokeWidth(5);
		// ラインエフェクトの描画
		for (i = 0; i < 8; i++) {
			if (line_eff_count[i] > 0) {
				paint.setAlpha(255 * line_eff_count[i] / line_eff_time);
				switch (i) {
				case 0:
					canvas.drawBitmap(line_eff1, keyPoint[i].x, judg_line
							- line_eff1.getHeight(), paint);
					break;
				case 1:
				case 3:
				case 5:
				case 7:
					canvas.drawBitmap(line_eff2, keyPoint[i].x, judg_line
							- line_eff2.getHeight(), paint);
					break;
				case 2:
				case 4:
				case 6:
					canvas.drawBitmap(line_eff3, keyPoint[i].x, judg_line
							- line_eff3.getHeight(), paint);
					break;
				}

				for (k = 0; k < 8; k++) {
					if (button[k].touch_flag == false) {
						line_eff_count[k] -= 1;
					}
				}
			}
		}
		paint.setAlpha(255);
		// ノートの描写
		for (i = 0; i < 9; i++) {
			for (j = finish_position[i]; j < now_position[i]; j++) {
				paint.setStrokeWidth(5);
				switch (i) {
				case 0:
					paint.setColor(Color.RED);
					break;
				case 1:
				case 3:
				case 5:
				case 7:
					paint.setColor(Color.WHITE);
					break;
				case 2:
				case 4:
				case 6:
					paint.setColor(Color.BLUE);
					break;
				case 8:
					paint.setStrokeWidth(1);
					paint.setColor(Color.WHITE);
				}
				k = (int) (judg_line * (1 - ((double) (L_bms.chkey[i][j] - now_time) / show_time)));
				if (k > judg_line) {
					k = judg_line;
					if (auto_flag && i != 8) {
						button[i].push_flag = true;
					}
				}
				canvas.drawLine(keyPoint[i].x, k, keyPoint[i].y, k, paint);
			}
		}
		// ボタンエフェクトの描写

		// レーンカバーの描写
		if (lean_flag == true) {
			canvas.drawBitmap(leancaver, 22,
					leanposition - leancaver.getHeight(), null);
		}
		switch(Timing){
		case 1:
			paint.setColor(Color.BLUE);
			paint.setTextSize(20);
			canvas.drawText("FAST", 90, 250, paint);
			break;
		case -1:
			paint.setColor(Color.RED);
			paint.setTextSize(20);
			canvas.drawText("SLOW", 90, 250, paint);
		}
		
		// comboの描写
		if (combo >= 1) {
			paint.setColor(Color.GREEN);
			paint.setTextSize(30);
			canvas.drawText("COMBO " + combo, 30, 280, paint);
		}
		// 描写
		holder.unlockCanvasAndPost(canvas);
	}

	private void Draw_Hard(int y1, int y2) {
		canvas = holder.lockCanvas();
		// 背景の描画
		canvas.drawColor(Color.rgb(0, 0, 0));
		// フレームの描写
		canvas.drawBitmap(frame, 0, 0, null);
		// ゲージの描写
		for (i = 0; i < 50; i++) {
			canvas.drawBitmap(Gage[2], 8 + i * 6, 473, paint);
		}
		paint.setAlpha(255);
		// レーンカバーの描写
		if (lean_flag == true) {
			canvas.drawBitmap(leancaver, 22,
					leanposition - leancaver.getHeight(), null);
		}
		canvas.drawBitmap(shutter[0], 0, y1 - shutter[0].getHeight(), null);
		canvas.drawBitmap(shutter[1], 0, y2, null);

		// 描写
		holder.unlockCanvasAndPost(canvas);
	}

	private void Draw_Result(int time) {
		int top_pad = 70;
		int LR_pad = 10;
		int width = getWidth() - LR_pad * 2;
		int height = 150;
		paint.setStyle(Paint.Style.FILL);
		canvas = holder.lockCanvas();
		canvas.drawColor(Color.BLACK);
		// タイトルの描写
		paint.setColor(Color.WHITE);
		paint.setTextAlign(Paint.Align.CENTER);
		paint.setTextSize(38);
		canvas.drawText(L_bms.TITLE, getWidth() / 2, 50, paint);

		paint.setTextSize(10);
		paint.setTextAlign(Paint.Align.LEFT);
		canvas.drawText("・RESULT GRAPH", LR_pad, top_pad - 4, paint);
		paint.setTextSize(34);
		canvas.drawText("TOTAL NOTES:", LR_pad, height + top_pad + 30*2, paint);
		canvas.drawText("MAX COMBO:", LR_pad, height + top_pad+ 30*3, paint);
		canvas.drawText("MISS COUNT:", LR_pad, height + top_pad+ 30*4, paint);
		paint.setTextAlign(Paint.Align.RIGHT);
		canvas.drawText(""+L_bms.Max_noat,getWidth()- LR_pad, height + top_pad + 30*2, paint);
		canvas.drawText(""+now_Maxcombo,getWidth()- LR_pad, height + top_pad+ 30*3, paint);
		canvas.drawText(""+now_MISS,getWidth()- LR_pad, height + top_pad+ 30*4, paint);
		
		paint.setTextAlign(Paint.Align.LEFT);
		canvas.drawText("GREAT:" + Hantei[2], LR_pad, height + top_pad+ 30*6, paint);
		canvas.drawText("GOOD:" + Hantei[1], LR_pad, height + top_pad+ 30*7, paint);
		canvas.drawText("MISS :" + Hantei[0], LR_pad, height + top_pad+ 30*8, paint);
		canvas.drawText("EXscore:" + score, LR_pad, height + top_pad + 30*9, paint);		
		

		paint.setColor(Color.rgb(0, 74, 23));
		canvas.drawRect(LR_pad, top_pad, width + LR_pad, height + top_pad,
				paint);
		paint.setColor(Color.rgb(128, 0, 1));
		canvas.drawRect(LR_pad, top_pad, width + LR_pad, height * 20 / 100
				+ top_pad, paint);

		boolean draw_flag = false;
		Path path = new Path();
		paint.setStyle(Paint.Style.STROKE);
		paint.setStrokeWidth(3);
		path.moveTo(LR_pad, height + top_pad - height * result_glaf[0] / 100);
		if (game_type == 0 || game_type == 1) {
			for (i = 0; i < time; i++) {
				path.lineTo(LR_pad + width * i / 99, height + top_pad - height
						* result_glaf[i] / 100);
				if (draw_flag == false) {
					if (result_glaf[i] > 80 || i == time - 1) {
						paint.setColor(Color.rgb(1, 255, 1));
						canvas.drawPath(path, paint);
						path = new Path();
						path.moveTo(LR_pad + width * i / 99, height + top_pad
								- height * result_glaf[i] / 100);
						draw_flag = true;
					}
				} else {
					if (result_glaf[i] < 80 || i == time - 1) {
						paint.setColor(Color.rgb(255, 0, 0));
						canvas.drawPath(path, paint);
						path = new Path();
						path.moveTo(LR_pad + width * i / 99, height + top_pad
								- height * result_glaf[i] / 100);
						draw_flag = false;
					}
				}
			}
		}
		if (game_type == 2) {
			paint.setColor(Color.rgb(128, 0, 1));
			paint.setStyle(Paint.Style.FILL);
			canvas.drawRect(LR_pad, top_pad, width + LR_pad, height + top_pad,
					paint);
			for (i = 0; i < time; i++) {
				path.lineTo(LR_pad + width * i / 99, height + top_pad - height
						* result_glaf[i] / 100);
			}
			paint.setStyle(Paint.Style.STROKE);
			paint.setColor(Color.rgb(255, 0, 0));
			canvas.drawPath(path, paint);
		}
		// 描写
		holder.unlockCanvasAndPost(canvas);
	}

	public void BGM_load() {
		// SDカード内のファイルを読んだプレイヤーを生成
		Uri.Builder builder = new Uri.Builder();
		builder.path(L_bms.file_path + "/" + L_bms.music_File);
		builder.scheme("file");
		BGM = MediaPlayer.create(context, builder.build());
		// _mp.prepare();
		if (BGM == null) {
			Toast toast = Toast.makeText(context,
					"音データがありません。または、音定義が複数あるため再生できませんでした", Toast.LENGTH_SHORT);
			toast.show();
		}
	}

	private static class Point {
		public int x;
		public int y;

		private Point(int x, int y) {
			this.x = x;
			this.y = y;
		}
	}

	public void surfaceDestroyed(SurfaceHolder holder) {
		tread_flag = false;
	}

	public void surfaceCreated(SurfaceHolder holder) {
		setClickable(true);
		setFocusable(true);
		for (i = 0; i < 9; i++) {
			for (j = 0; j < L_bms.chkey[i].length; j++) {
				if (L_bms.chkey[i][j] == 999999) {
					break;
				}
				L_bms.chkey[i][j] += sleeptime + cont_time + 200;
			}
		}
		System.gc();
		BGM.stop();
		thread = new Thread(this);
		thread.start();
	}

	public void surfaceChanged(SurfaceHolder arg0, int arg1, int arg2, int arg3) {
		// TODO 自動生成されたメソッド・スタブ

	}
}